/*==================================================================================================
* Package : S32Z2E2 BIST example source code
* File    : STCU.h
*
*   Copyright 2024 NXP
*   NXP Confidential and Proprietary. This software is owned or controlled by NXP and may only
*   be used strictly in accordance with the applicable license terms. By expressly accepting
*   such terms or by downloading, installing, activating and/or otherwise using the software,
*   you are agreeing that you have read, and that you agree to comply with and are bound by,
*   such license terms. If you do not agree to be bound by the applicable license terms, then
*   you may not retain, install, activate or otherwise use the software.
*
*   THIS SOFTWARE IS PROVIDED BY NXP "AS IS" AND ANY EXPRESSED OR
*   IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
*   OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
*   IN NO EVENT SHALL NXP OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
*   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
*   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
*   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
*   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
*   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
*   IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
*   THE POSSIBILITY OF SUCH DAMAGE.
*
==================================================================================================*/

#ifndef STCU_H_
#define STCU_H_

#define RTU0	0
#define RTU1	1

#define MBIST_ALGO_WriteChk		1
#define MBIST_ALGO_MarchCm		2
#define MBIST_ALGO_MarchMSS1	4
#define MBIST_ALGO_AddrDecode	8
#define MBIST_ALGO_BitLineLeak	0x10
#define MBIST_ALGO_BasicChk		0x20
#define MBIST_ALGO_MemInit		0x40
#define MBIST_ALGO_MarchCp		0x80


void enable_r52_cluster_fence_drain(int id, vuint32_t fd, vuint32_t slave_fd, vuint32_t iso_en) ;
void enable_rtu_sys_master_fence_drain(int id) ;
void wait_for_rtu_noc_idle(int id) ;
void enable_output_isolation(int id) ;

void lbist_setup_mmc () ;
void set_mbist (uint32_t addr, uint32_t algo) ;
void mbist_setup_mtr (uint32_t algo) ;

void EnableRTU (int id) ;
void DisableRTU (int id) ;

void SetupAndRunSTCU() ;

#endif /* STCU_H_ */
